From 4c833569fb1233793256332a3b97d7b2afa60da6 Mon Sep 17 00:00:00 2001
From: David Seifert <soap@gentoo.org>
Date: Fri, 30 Jun 2023 15:35:12 +0200
Subject: [PATCH] Replace obsolescent `%hs` printf specifier

* `%hs` is not defined by C:
  https://wiki.sei.cmu.edu/confluence/display/c/FIO47-C.+Use+valid+format+strings
* Fixes translations for gettext 0.22

Bug: https://bugs.gentoo.org/909201
Closes: #4847
---
 locale/ar.po             | 2 +-
 locale/be.po             | 6 +++---
 locale/bg.po             | 2 +-
 locale/ca.po             | 2 +-
 locale/ca_ES@valencia.po | 2 +-
 locale/fa.po             | 4 ++--
 locale/gl.po             | 2 +-
 locale/hr.po             | 2 +-
 locale/hy.po             | 2 +-
 locale/id.po             | 2 +-
 locale/km.po             | 4 ++--
 locale/ro.po             | 2 +-
 locale/sr_RS@latin.po    | 2 +-
 locale/ta.po             | 2 +-
 locale/tg.po             | 4 ++--
 15 files changed, 20 insertions(+), 20 deletions(-)

diff --git a/locale/ar.po b/locale/ar.po
index 2abe618f516..40f60e06807 100644
--- a/locale/ar.po
+++ b/locale/ar.po
@@ -2304,7 +2304,7 @@ msgstr "لم أتمكن من فتح ملف: \"%s\""
 #: libraries/lib-xml/XMLFileReader.cpp
 #, fuzzy, c-format
 msgid "Error: %s at line %lu"
-msgstr "خطأ: %hs عند خط %lu"
+msgstr "خطأ: %s عند خط %lu"
 
 #: libraries/lib-xml/XMLFileReader.cpp
 #, c-format
diff --git a/locale/be.po b/locale/be.po
index 017d1d67ded..4ae28b8e410 100644
--- a/locale/be.po
+++ b/locale/be.po
@@ -2320,7 +2320,7 @@ msgstr "Не атрымалася адкрыць файл: \"%s\""
 #: libraries/lib-xml/XMLFileReader.cpp
 #, fuzzy, c-format
 msgid "Error: %s at line %lu"
-msgstr "Памылка: %hs у радку %lu"
+msgstr "Памылка: %s у радку %lu"
 
 #: libraries/lib-xml/XMLFileReader.cpp
 #, c-format
@@ -4469,7 +4469,7 @@ msgstr "Больш не паказваць гэта папярэджанне"
 #: src/FileFormats.cpp
 #, c-format
 msgid "Error (file may not have been written): %s"
-msgstr "Памылка (магчыма, файл не запісаны): %hs"
+msgstr "Памылка (магчыма, файл не запісаны): %s"
 
 #: src/FileFormats.cpp
 #, fuzzy
@@ -20925,7 +20925,7 @@ msgstr ""
 #: plug-ins/eq-xml-to-txt-converter.ny
 #, fuzzy, lisp-format
 msgid "Error.~%File cannot be written:~%\"~a.txt\""
-msgstr "Памылка (магчыма, файл не запісаны): %hs"
+msgstr "Памылка (магчыма, файл не запісаны): %s"
 
 #: plug-ins/equalabel.ny
 msgid "Regular Interval Labels"
diff --git a/locale/bg.po b/locale/bg.po
index e3d22e24da5..119d386c004 100644
--- a/locale/bg.po
+++ b/locale/bg.po
@@ -2328,7 +2328,7 @@ msgstr "Не бе възможно да се отвори файл: „%s“"
 #: libraries/lib-xml/XMLFileReader.cpp
 #, fuzzy, c-format
 msgid "Error: %s at line %lu"
-msgstr "Грешка: %hs на ред %lu"
+msgstr "Грешка: %s на ред %lu"
 
 #: libraries/lib-xml/XMLFileReader.cpp
 #, c-format
diff --git a/locale/ca.po b/locale/ca.po
index aefd1e0e452..36448c45373 100644
--- a/locale/ca.po
+++ b/locale/ca.po
@@ -2299,7 +2299,7 @@ msgstr "No s'ha pogut obrir el fitxer: «%s»"
 #: libraries/lib-xml/XMLFileReader.cpp
 #, fuzzy, c-format
 msgid "Error: %s at line %lu"
-msgstr "Error: %hs a la línia %lu"
+msgstr "Error: %s a la línia %lu"
 
 #: libraries/lib-xml/XMLFileReader.cpp
 #, c-format
diff --git a/locale/ca_ES@valencia.po b/locale/ca_ES@valencia.po
index a498281e778..5545ae76eef 100644
--- a/locale/ca_ES@valencia.po
+++ b/locale/ca_ES@valencia.po
@@ -2319,7 +2319,7 @@ msgstr "No s'ha pogut obrir el fitxer: «%s»"
 #: libraries/lib-xml/XMLFileReader.cpp
 #, fuzzy, c-format
 msgid "Error: %s at line %lu"
-msgstr "Error: %hs en la línia %lu"
+msgstr "Error: %s en la línia %lu"
 
 #: libraries/lib-xml/XMLFileReader.cpp
 #, c-format
diff --git a/locale/fa.po b/locale/fa.po
index 0374b06ce9a..ba983177842 100644
--- a/locale/fa.po
+++ b/locale/fa.po
@@ -4413,7 +4413,7 @@ msgstr ""
 #: src/FileFormats.cpp
 #, c-format
 msgid "Error (file may not have been written): %s"
-msgstr "خطا (ممکن است در پرونده نوشته شده باشد) : %hs"
+msgstr "خطا (ممکن است در پرونده نوشته شده باشد) : %s"
 
 #: src/FileFormats.cpp
 msgid "&Copy uncompressed files into the project (safer)"
@@ -20567,7 +20567,7 @@ msgstr ""
 #: plug-ins/eq-xml-to-txt-converter.ny
 #, fuzzy, lisp-format
 msgid "Error.~%File cannot be written:~%\"~a.txt\""
-msgstr "خطا (ممکن است در پرونده نوشته شده باشد) : %hs"
+msgstr "خطا (ممکن است در پرونده نوشته شده باشد) : %s"
 
 #: plug-ins/equalabel.ny
 msgid "Regular Interval Labels"
diff --git a/locale/gl.po b/locale/gl.po
index d2869ae5e41..c30b70b93da 100644
--- a/locale/gl.po
+++ b/locale/gl.po
@@ -2325,7 +2325,7 @@ msgstr "Non foi posíbel abrir o ficheiro: «%s»"
 #: libraries/lib-xml/XMLFileReader.cpp
 #, fuzzy, c-format
 msgid "Error: %s at line %lu"
-msgstr "Erro: %hs na liña %lu"
+msgstr "Erro: %s na liña %lu"
 
 #: libraries/lib-xml/XMLFileReader.cpp
 #, c-format
diff --git a/locale/hr.po b/locale/hr.po
index 21259b91c28..7fe86224c2c 100644
--- a/locale/hr.po
+++ b/locale/hr.po
@@ -2333,7 +2333,7 @@ msgstr "Pogrješka pri otvaranju datoteke: \"%s\""
 #: libraries/lib-xml/XMLFileReader.cpp
 #, fuzzy, c-format
 msgid "Error: %s at line %lu"
-msgstr "Pogrješka: %hs u retku %lu"
+msgstr "Pogrješka: %s u retku %lu"
 
 #: libraries/lib-xml/XMLFileReader.cpp
 #, c-format
diff --git a/locale/hy.po b/locale/hy.po
index 4486bb40342..5e7f695565d 100644
--- a/locale/hy.po
+++ b/locale/hy.po
@@ -2323,7 +2323,7 @@ msgstr "Չի ստացվում բացել ֆայլը՝ \"%s\""
 #: libraries/lib-xml/XMLFileReader.cpp
 #, fuzzy, c-format
 msgid "Error: %s at line %lu"
-msgstr "Սխալ՝ %hs  %lu գծում"
+msgstr "Սխալ՝ %s  %lu գծում"
 
 #: libraries/lib-xml/XMLFileReader.cpp
 #, c-format
diff --git a/locale/id.po b/locale/id.po
index bf8b8b2d5bc..d7ed1b5c497 100644
--- a/locale/id.po
+++ b/locale/id.po
@@ -2326,7 +2326,7 @@ msgstr "Tidak bisa membuka file:\"%s\""
 #: libraries/lib-xml/XMLFileReader.cpp
 #, fuzzy, c-format
 msgid "Error: %s at line %lu"
-msgstr "Error: %hs pada garis %lu"
+msgstr "Error: %s pada garis %lu"
 
 #: libraries/lib-xml/XMLFileReader.cpp
 #, c-format
diff --git a/locale/km.po b/locale/km.po
index 2617d867398..9f1b5ef629e 100644
--- a/locale/km.po
+++ b/locale/km.po
@@ -4432,7 +4432,7 @@ msgstr ""
 #: src/FileFormats.cpp
 #, fuzzy, c-format
 msgid "Error (file may not have been written): %s"
-msgstr "កំហុស (ឯកសារ​អាច​មិន​ទាន់​ត្រូវ​បាន​សរសេរ) ៖ %hs"
+msgstr "កំហុស (ឯកសារ​អាច​មិន​ទាន់​ត្រូវ​បាន​សរសេរ) ៖ %s"
 
 #: src/FileFormats.cpp
 msgid "&Copy uncompressed files into the project (safer)"
@@ -20656,7 +20656,7 @@ msgstr ""
 #: plug-ins/eq-xml-to-txt-converter.ny
 #, fuzzy, lisp-format
 msgid "Error.~%File cannot be written:~%\"~a.txt\""
-msgstr "កំហុស (ឯកសារ​អាច​មិន​ទាន់​ត្រូវ​បាន​សរសេរ) ៖ %hs"
+msgstr "កំហុស (ឯកសារ​អាច​មិន​ទាន់​ត្រូវ​បាន​សរសេរ) ៖ %s"
 
 #: plug-ins/equalabel.ny
 msgid "Regular Interval Labels"
diff --git a/locale/ro.po b/locale/ro.po
index 4a1ef8b497d..4207cd9c809 100644
--- a/locale/ro.po
+++ b/locale/ro.po
@@ -2255,7 +2255,7 @@ msgstr "Nu s-a putut deschide fișierul: „%s”"
 #: libraries/lib-xml/XMLFileReader.cpp
 #, fuzzy, c-format
 msgid "Error: %s at line %lu"
-msgstr "Eroare: %hs la linia %lu"
+msgstr "Eroare: %s la linia %lu"
 
 #: libraries/lib-xml/XMLFileReader.cpp
 #, c-format
diff --git a/locale/sr_RS@latin.po b/locale/sr_RS@latin.po
index 2c8adc0cec3..68d2f41fd09 100644
--- a/locale/sr_RS@latin.po
+++ b/locale/sr_RS@latin.po
@@ -2330,7 +2330,7 @@ msgstr "Ne mogu da otvorim datoteku: „%s“"
 #: libraries/lib-xml/XMLFileReader.cpp
 #, fuzzy, c-format
 msgid "Error: %s at line %lu"
-msgstr "Greška: %hs u redu %lu"
+msgstr "Greška: %s u redu %lu"
 
 #: libraries/lib-xml/XMLFileReader.cpp
 #, c-format
diff --git a/locale/ta.po b/locale/ta.po
index 52fc75eb9db..edf03a5290d 100644
--- a/locale/ta.po
+++ b/locale/ta.po
@@ -2308,7 +2308,7 @@ msgstr "கோப்பை திறக்க முடியவில்லை:
 #: libraries/lib-xml/XMLFileReader.cpp
 #, fuzzy, c-format
 msgid "Error: %s at line %lu"
-msgstr "பிழை: %hs வரிசை %lu"
+msgstr "பிழை: %s வரிசை %lu"
 
 #: libraries/lib-xml/XMLFileReader.cpp
 #, c-format
diff --git a/locale/tg.po b/locale/tg.po
index a88ff86bca5..ce5d5a8b2c2 100644
--- a/locale/tg.po
+++ b/locale/tg.po
@@ -4422,7 +4422,7 @@ msgstr ""
 #: src/FileFormats.cpp
 #, fuzzy, c-format
 msgid "Error (file may not have been written): %s"
-msgstr "Хато (файл сабт намешавад): %hs"
+msgstr "Хато (файл сабт намешавад): %s"
 
 #: src/FileFormats.cpp
 msgid "&Copy uncompressed files into the project (safer)"
@@ -20628,7 +20628,7 @@ msgstr ""
 #: plug-ins/eq-xml-to-txt-converter.ny
 #, fuzzy, lisp-format
 msgid "Error.~%File cannot be written:~%\"~a.txt\""
-msgstr "Хато (файл сабт намешавад): %hs"
+msgstr "Хато (файл сабт намешавад): %s"
 
 #: plug-ins/equalabel.ny
 msgid "Regular Interval Labels"